<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Module: datetime</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Module: datetime</h1>
              



<section>
    
<header>
    <!--h2>
    datetime
    </h2-->
    
</header>  

<article>
    <div class="container-overview hero-unit">
    

    

    
    
    
        
            <div class="description"><p><p>The datetime module provides a collection of utility methods for manipulating dates and allows you to choosing
user-defined patterns for date-time formatting.</p>
<p>Date and time formats are specified by date and time pattern strings. The pattern strings are designed to
conform to java.text.SimpleDateFormat.</p>
<h5>Usage</h5><pre class="prettyprint source"><code>// Mar 04 2010 05:06:07.008 GMT+0800
var time = new Date(new Date(Date.UTC(2010, 2, 4, 5, 6, 7, 8)).getTime() - 8 * 3600000);</p><p>// Mar 04 2010 05:06:07.008 at local time
var localTime = new Date(2010, 2, 4, 5, 6, 7, 8);</p><p>// Mar 04 2010 at local time
var localDate = new Date(2010, 2, 4);</p><p>// ISO 8601 data & time representation format.
expect(datetime.format(time)).to.equal(&quot;2010-03-04T05:06:07.008+0800&quot;);
expect(datetime.format(localTime, &quot;yyyy/MM/dd HH:mm:ss.SSS&quot;)).to.equal(&quot;2010/03/04 05:06:07.008&quot;);
expect(datetime.format(localTime, &quot;yyyy/MM/dd HH:mm:ss&quot;)).to.equal(&quot;2010/03/04 05:06:07&quot;);
expect(datetime.format(localDate, &quot;yyyy/MM/dd&quot;)).to.equal(&quot;2010/03/04&quot;);
expect(datetime.format(localDate, &quot;yyyy/M/d&quot;)).to.equal(&quot;2010/3/4&quot;);</p><p>// ISO 8601 data & time representation format.
expect(datetime.parse(&quot;2010-03-04T05:06:07.008+0800&quot;)).to.equalTime(time);
expect(datetime.parse(&quot;2010/03/04 05:06:07.008&quot;, &quot;yyyy/MM/dd HH:mm:ss.SSS&quot;)).to.equalTime(localTime);
expect(datetime.parse(&quot;2010/03/04&quot;, &quot;yyyy/MM/dd&quot;)).to.equalTime(localDate);
expect(datetime.parse(&quot;2010/3/4&quot;, &quot;yyyy/M/d&quot;)).to.equalTime(localDate);</p><p>expect(datetime.convert(&quot;2010-03-04T05:06:07.008+0800&quot;)).to.equalTime(time);
expect(datetime.convert(time.getTime())).to.equalTime(time);
expect(datetime.convert(&quot;2010/03/04 05:06:07.008&quot;, &quot;yyyy/MM/dd HH:mm:ss.SSS&quot;)).to.equalTime(localTime);
expect(datetime.convert(&quot;2010/03/04&quot;, &quot;yyyy/MM/dd&quot;)).to.equalTime(localDate);</code></pre></p></div>
        
        
        
<dl class="details">
    
        
    
    
    
    <dt class="tag-since">Since:</dt>
    <dd class="tag-since"><ul class="dummy"><li>1.0</dd>
    

    
    
    
    
    
    <dt class="tag-author">Author:</dt>
    <dd class="tag-author">
        <ul>
            <li>Jason Lin</li>
        </ul>
    </dd>
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

        
        
    
    </div>
    
    
    
    
    
    
    
    
    
    
        <h3 class="subsection-title">Methods</h3>
        
        <dl class="bs-docs-example bs-methods">
            
<dt>
    <h4 class="name" id=".convert"><span class="label label-info">static</span> convert<span class="signature">(value, <span class="optional">pattern</span>)</span><span class="type-signature"> &rarr; {Date}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>The method converts a value to a date using the specified pattern.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		
		<th>Default</th>
		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">value</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>
|

<span class="param-type">Number</span>
|

<span class="param-type">Date</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>the value to convert.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">pattern</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            
                <td class="default">
                
                    "yyyy-MM-ddTHH:mm:ss.SSSZ"
                
                </td>
            

            <td class="description last"><p>specify a date pattern to parse the text.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Date</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id=".format"><span class="label label-info">static</span> format<span class="signature">(value, <span class="optional">pattern</span>)</span><span class="type-signature"> &rarr; {String|null}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>The method formats a date to a string representation using the specified pattern.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		
		<th>Default</th>
		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">value</td>
            

            <td class="type">
            
                
<span class="param-type">Date</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>the date to format.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">pattern</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            
                <td class="default">
                
                    "yyyy-MM-ddTHH:mm:ss.SSSZ"
                
                </td>
            

            <td class="description last"><p>specify a date pattern to format the value.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">String</span>
|

<span class="param-type">null</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id=".parse"><span class="label label-info">static</span> parse<span class="signature">(text, <span class="optional">pattern</span>)</span><span class="type-signature"> &rarr; {Date|void}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>The method parses a string representation of a date using the specified pattern and returns the date.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		
		<th>Default</th>
		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">text</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>the text to convert.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">pattern</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            
                <td class="default">
                
                    "yyyy-MM-ddTHH:mm:ss.SSSZ"
                
                </td>
            

            <td class="description last"><p>specify a date pattern to parse the text.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Date</span>
|

<span class="param-type">void</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id=".test"><span class="label label-info">static</span> test<span class="signature">(text, <span class="optional">pattern</span>)</span><span class="type-signature"> &rarr; {Boolean}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>The method tests if a string representation is a date using a specified pattern.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		
		<th>Default</th>
		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">text</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>the text to check.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">pattern</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            
                <td class="default">
                
                    "yyyy-MM-ddTHH:mm:ss.SSSZ"
                
                </td>
            

            <td class="description last"><p>specify a date pattern to check the text.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Boolean</span>




</div>

        
    
    
</dd>

        </dl>
    
    
    
    
    
</article>

</section>  




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:20 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>